<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: HttpClient</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: HttpClient</h1>






<section>

<header>

        <h2><span class="attribs"><span class="type-signature"></span></span>HttpClient<span class="signature">()</span><span class="type-signature"> &rarr; {Promise}</span></h2>

            <div class="class-description"><p>This class is responsible to make the authentication, token validation and sending request</p></div>


</header>

<article>
    <div class="container-overview">




    <h2>Constructor</h2>



    <h4 class="name" id="HttpClient"><span class="type-signature"></span>new HttpClient<span class="signature">()</span><span class="type-signature"> &rarr; {Promise}</span></h4>


















<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line13">line 13</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>








    </div>
















        <h3 class="subsection-title">Methods</h3>







    <h4 class="name" id="delete"><span class="type-signature"></span>delete<span class="signature">(url, params)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to make a delete request to an endpoint after token validation</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>url</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>endpoint uri</p></td>
        </tr>



        <tr>

                <td class="name"><code>params</code></td>


            <td class="type">


<span class="param-type">params</span>



            </td>





            <td class="description last"><p>Json Object</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line125">line 125</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













    <h4 class="name" id="get"><span class="type-signature"></span>get<span class="signature">(url, params)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to make a get request to an endpoint after token validation</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>url</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>endpoint uri</p></td>
        </tr>



        <tr>

                <td class="name"><code>params</code></td>


            <td class="type">


<span class="param-type">params</span>



            </td>





            <td class="description last"><p>Json Object</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line103">line 103</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













    <h4 class="name" id="getRequestConfiguration"><span class="type-signature"></span>getRequestConfiguration<span class="signature">(method)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to get the request configuration in which the headers are set. If a Get its requested just return a
request configuration without headers.</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>method</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>Http method (GET | POST | PATCH | DELETE)</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line26">line 26</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new  object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













    <h4 class="name" id="patch"><span class="type-signature"></span>patch<span class="signature">(url, params)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to make a patch request to an endpoint after token validation</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>url</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>endpoint uri</p></td>
        </tr>



        <tr>

                <td class="name"><code>params</code></td>


            <td class="type">


<span class="param-type">params</span>



            </td>





            <td class="description last"><p>Json Object</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line114">line 114</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













    <h4 class="name" id="post"><span class="type-signature"></span>post<span class="signature">(url, params)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to make a post to an endpoint after token validation</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>url</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>endpoint uri</p></td>
        </tr>



        <tr>

                <td class="name"><code>params</code></td>


            <td class="type">


<span class="param-type">params</span>



            </td>





            <td class="description last"><p>Json Object</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line92">line 92</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













    <h4 class="name" id="sendRequest"><span class="type-signature"></span>sendRequest<span class="signature">(url, method, params)</span><span class="type-signature"> &rarr; {Promise}</span></h4>






<div class="description">
    <p>This function is responsible to send a request to an endpoint after get the request configuration.</p>
</div>









    <h5>Parameters:</h5>


<table class="params">
    <thead>
    <tr>

        <th>Name</th>


        <th>Type</th>





        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>


        <tr>

                <td class="name"><code>url</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>endpoint uri</p></td>
        </tr>



        <tr>

                <td class="name"><code>method</code></td>


            <td class="type">


<span class="param-type">string</span>



            </td>





            <td class="description last"><p>Http method (GET | POST | PATCH | DELETE)</p></td>
        </tr>



        <tr>

                <td class="name"><code>params</code></td>


            <td class="type">


<span class="param-type">params</span>



            </td>





            <td class="description last"><p>Json Object</p></td>
        </tr>


    </tbody>
</table>






<dl class="details">


























    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="HttpClient.js.html">HttpClient.js</a>, <a href="HttpClient.js.html#line52">line 52</a>
    </li></ul></dd>







</dl>















<h5>Returns:</h5>


<div class="param-desc">
    <p>Returns a new Promise object which can be resolved or rejected if its not a 200 response.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>

<span class="param-type">Promise</span>


    </dd>
</dl>













</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="HttpClient.html">HttpClient</a></li><li><a href="MagentoClient.html">MagentoClient</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addDocuments">addDocuments</a></li><li><a href="global.html#addProduct">addProduct</a></li><li><a href="global.html#addTags">addTags</a></li><li><a href="global.html#Channels-SDK_Example">Channels-SDK_Example</a></li><li><a href="global.html#Countries-SDK_Example">Countries-SDK_Example</a></li><li><a href="global.html#default">default</a></li><li><a href="global.html#Documents-SDK_Example">Documents-SDK_Example</a></li><li><a href="global.html#filter">filter</a></li><li><a href="global.html#generateEndpointsCrudMethods">generateEndpointsCrudMethods</a></li><li><a href="global.html#getProducts">getProducts</a></li><li><a href="global.html#getSalesPerson">getSalesPerson</a></li><li><a href="global.html#getTradeShows">getTradeShows</a></li><li><a href="global.html#importAndExecuteModules">importAndExecuteModules</a></li><li><a href="global.html#ProductCategories-SDK_Example">ProductCategories-SDK_Example</a></li><li><a href="global.html#Products-SDK_Example">Products-SDK_Example</a></li><li><a href="global.html#Recipes-SDK_Example">Recipes-SDK_Example</a></li><li><a href="global.html#removeTags">removeTags</a></li><li><a href="global.html#retrieveRecipes">retrieveRecipes</a></li><li><a href="global.html#SalesPerson-SDK_Example">SalesPerson-SDK_Example</a></li><li><a href="global.html#salesPersonModule">salesPersonModule</a></li><li><a href="global.html#SalesRepresentative-SDK_Example">SalesRepresentative-SDK_Example</a></li><li><a href="global.html#Samples-SDK_Example">Samples-SDK_Example</a></li><li><a href="global.html#setSalesPerson">setSalesPerson</a></li><li><a href="global.html#setTradeShow">setTradeShow</a></li><li><a href="global.html#synchronize">synchronize</a></li><li><a href="global.html#Tags-SDK_Example">Tags-SDK_Example</a></li><li><a href="global.html#Tradeshow-SDK_Example">Tradeshow-SDK_Example</a></li><li><a href="global.html#UserTypes-SDK_Example">UserTypes-SDK_Example</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Nov 22 2019 13:09:48 GMT-0600 (Central Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
